/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomXPathEvaluator_H__
#define __GdomXPathEvaluator_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomNode.h"
#include "gdom/GdomXPathExpression.h"
#include "gdom/GdomXPathNSResolver.h"
#include "gdom/GdomXPathResult.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomXPathEvaluator GdomXPathEvaluator;
typedef struct _GdomXPathEvaluatorClass GdomXPathEvaluatorClass;


#define GDOM_TYPE_X_PATH_EVALUATOR            (gdom_x_path_evaluator_get_type())
#define GDOM_X_PATH_EVALUATOR(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_X_PATH_EVALUATOR, GdomXPathEvaluator))
#define GDOM_X_PATH_EVALUATOR_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_X_PATH_EVALUATOR, GdomXPathEvaluator)Class)
#define GDOM_IS_X_PATH_EVALUATOR(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_X_PATH_EVALUATOR))
#define GDOM_IS_X_PATH_EVALUATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_X_PATH_EVALUATOR))
#define GDOM_X_PATH_EVALUATOR_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_X_PATH_EVALUATOR, GdomXPathEvaluatorClass))

typedef struct _GdomXPathEvaluatorPrivate GdomXPathEvaluatorPrivate;

struct _GdomXPathEvaluator {
    GdomDOMObject parent_instance;
    GdomXPathEvaluatorPrivate *priv;
};

struct _GdomXPathEvaluatorClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_x_path_evaluator_get_type (void);

WEBKIT_API GdomXPathExpression *
gdom_x_path_evaluator_create_expression (GdomXPathEvaluator *thiz, gchar * expression, GdomXPathNSResolver * resolver);

WEBKIT_API GdomXPathNSResolver *
gdom_x_path_evaluator_create_ns_resolver (GdomXPathEvaluator *thiz, GdomNode * node_resolver);

WEBKIT_API GdomXPathResult *
gdom_x_path_evaluator_evaluate (GdomXPathEvaluator *thiz, gchar * expression, GdomNode * context_node, GdomXPathNSResolver * resolver, gushort type, GdomXPathResult * in_result);

G_END_DECLS

#endif /* __GdomXPathEvaluator_H__ */
